/**************************************************************** 
 * Description: 
 * Author: Alex Li
 * Date: 2024-08-19 19:25:16
 * LastEditTime: 2024-08-19 19:46:07
****************************************************************/
#include<iostream>
#define int  long long // 使用 unsigned long long 类型，可以防止溢出
using namespace std;

int sum[2050][2050], temp, n, m, q, ans;
int u, v, x, y;

signed main() {
    int t;
    cin >> t; // 输入测试用例的数量
    while (t--) {
        ans = 0; // 每次测试用例都要重置 ans，防止前一次结果影响后续
        cin >> n >> m >> q; // 输入矩阵的行数、列数，以及查询的次数

        // 预处理前缀和数组
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                cin >> temp; // 输入矩阵元素
                // 计算前缀和，利用二维前缀和公式
                sum[i][j] = sum[i-1][j] + sum[i][j-1] - sum[i-1][j-1] + temp;
            }
        } // O(nm) 复杂度的预处理，用于后续快速查询子矩形和

        // 处理每个查询
        for (int i = 1; i <= q; i++) {
            cin >> u >> v >> x >> y; // 输入每个查询的子矩形范围
            // 使用前缀和快速求出子矩形的元素和
            ans= sum[x][y] + sum[u-1][v-1] - sum[u-1][y] - sum[x][v-1];
            cout << ans << endl; // 输出结果，并换行
        } // 使用异或运算处理多个查询的答案，避免数值过大

       // cout << ans << endl; // 输出结果，并换行
    }
    return 0;
}
